package com.contentsquare.flutter.infrastructure.core.method_call_executor.agents

import com.contentsquare.flutter.infrastructure.core.method_call_executor.data.ExecutionData
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.ExecutionResponse
import com.contentsquare.flutter.infrastructure.core.method_call_executor.responses.SuccessExecutionResponse
import com.contentsquare.flutter.infrastructure.proxies.OnSessionReplayLinkChangeProxy
import io.flutter.plugin.common.MethodChannel

internal class OnSessionReplayLinkChangeAgent(proxy: OnSessionReplayLinkChangeProxy?=null, channel: MethodChannel): MethodCallAgent(nativeExceptionMessage) {

    private val _proxy: OnSessionReplayLinkChangeProxy = proxy ?: OnSessionReplayLinkChangeProxy.default(channel = channel)


    companion object {
        /** Message to use in case of error during native call. */
        val nativeExceptionMessage = "Failed to ${AgentMethod.LISTEN_TO_SESSION_REPLAY_LINK_CHANGE.method}"
    }

    override fun execute(data: ExecutionData): ExecutionResponse {
        _proxy.onSessionReplayLinkChange()
        return SuccessExecutionResponse.empty()
    }
}