package com.contentsquare.flutter.infrastructure.core.platform_views

import android.view.View
import io.flutter.embedding.engine.FlutterEngine


/**
 * A class used to provide the [View] created through the
 * PlatformView mechanism of Flutter.
 */
internal class ViewFromIdProvider(private val flutterEngineProvider: FlutterEngineProvider) {
    fun getView(viewId: Int): View? {
        return flutterEngineProvider.getFlutterEngine()?.platformViewsController?.getPlatformViewById(viewId)
    }
}

/**
 * A provider for the [FlutterEngine] used in the application.
 */
internal interface FlutterEngineProvider {
    fun getFlutterEngine(): FlutterEngine?
}