class OnSessionReplayLinkChangeAgent: MethodCallAgent {
    
    internal init(flutterMethodChannel: FlutterMethodChannel, proxy: OnSessionReplayLinkChangeProxy? = nil) {
        self._channel = flutterMethodChannel
        self._proxy = proxy ?? OnSessionReplayLinkChangeProxyFactory.makeDefault(flutterMethodChannel: _channel)
    }
    
    static let exceptionMessage = "Exception occurred when listening to session replay link changes from native"
    
    private let _proxy: OnSessionReplayLinkChangeProxy
    private let _channel: FlutterMethodChannel

    var nativeExceptionMessage: String? {
        return OnSessionReplayLinkChangeAgent.exceptionMessage
    }
    
    func execute(data: ExecutionData) throws -> ExecutionResponse {
        try _proxy.onSessionReplayLinkChange()
        
        return ExecutionResponse.succeed(result: nil)
    }
  
}
