/// Class that helps to create the target view path used by the Flutter screen graph nodes as root.
class TargetViewPathCreator {
    let suffixToRemove = ">UIScrollView:eq(0)"
    
    /// Creates a target view path.
    ///
    /// Remove the [suffixToRemove] in the path so that it will be the same as the on gesture events.
    func create(rootPath: String) -> String {
        if rootPath.hasSuffix(suffixToRemove) {
            return String(rootPath.prefix(rootPath.count - suffixToRemove.count))
        }
        return rootPath
    }
}
