class AppInfoProvider {
    private static let keyPackageName = "packageName"
    private static let keyVersion = "version"
    private static let keyBuildNumber = "buildNumber"

    static func get() -> [String: String] {
        let packageName = Bundle.main.bundleIdentifier ?? ""
        let version = Bundle.main.object(forInfoDictionaryKey: "CFBundleShortVersionString") as? String ?? ""
        let buildNumber = Bundle.main.object(forInfoDictionaryKey: "CFBundleVersion") as? String ?? ""

        return [
            keyPackageName: packageName,
            keyVersion: version,
            keyBuildNumber: buildNumber
        ]
    }
}