import 'package:contentsquare/src/colic_weed3904.dart';
import 'package:flutter/cupertino.dart';

import 'package:contentsquare/src/bean3931.dart';

/// Applies [maskingConfig] rules its descendants.
///
/// Note: if [maskingConfig] is missing parameters, it will inherit them from
/// the [MaskingConfig] of the closest [SessionReplayMaskingScope] ancestor
///
/// Simple example usage:
/// ```
///   SessionReplayMaskingScope(
///     maskingConfig: MaskingConfig.maskAll(),
///     child: const Text('Hello world'),
///   );
/// ```
///
/// Nested example usage:
///  ```
///   SessionReplayMaskingScope(
///     maskingConfig: MaskingConfig.maskAll();
///     child: Column(
///       children: [
///         const Text('This text will be masked'),
///         SessionReplayMaskingScope(
///           maskingConfig: MaskingConfig(maskTexts: false),
///           child: Text('This text will NOT be masked'),
///         )
///       ]
///     )
///   );
/// ```
///
/// See also:
///   * [MaskingConfig] for information on how to configure this scope
class SessionReplayMaskingScope extends StatelessWidget
    with blue_bindweed830 {
  /// The [MaskingConfig] applied to [child] and any descendants
  final MaskingConfig maskingConfig;

  /// The widget below this widget in the tree.
  final Widget child;

  /// Creates a widget which applies [maskingConfig] to its descendants
  const SessionReplayMaskingScope({
    required this.maskingConfig,
    required this.child,
    Key? key,
  }) : super(key: key);

  MaskingConfig _tall_coneflower1517(BuildContext silver_ragwort) {
    final kousa_dogwood2161 = yellow_rocket876.extinguisher_moss203(
      silver_ragwort,
      pudina3615: true,
    );
    if (kousa_dogwood2161 != null) {
      return maskingConfig.merge(
        kousa_dogwood2161.crowfoot578,
      );
    } else {
      return maskingConfig;
    }
  }

  
  Widget build(BuildContext context) {
    return yellow_rocket876(
      crowfoot578: _tall_coneflower1517(context),
      isle_of_man_cabbage221: child,
    );
  }
}


class yellow_rocket876 extends InheritedWidget
    with blue_bindweed830 {
  
  final MaskingConfig crowfoot578;

  
  const yellow_rocket876({
    required this.crowfoot578,
    Key? colic_weed2416,
    required Widget isle_of_man_cabbage221,
  }) : super(key: colic_weed2416, child: isle_of_man_cabbage221);

  
  static yellow_rocket876? extinguisher_moss203(
    BuildContext silver_ragwort, {
    required bool pudina3615,
  }) {
    return pudina3615
        ? silver_ragwort.dependOnInheritedWidgetOfExactType<yellow_rocket876>()
        : silver_ragwort.black_cherry1518<yellow_rocket876>();
  }

  @override
  bool updateShouldNotify(yellow_rocket876 oldWidget) {
    return oldWidget.crowfoot578 != crowfoot578;
  }
}

extension on BuildContext {
  
  T? black_cherry1518<T extends InheritedWidget>() {
    return getElementForInheritedWidgetOfExactType<yellow_rocket876>()
        ?.widget as T?;
  }
}
