

import 'dart:async';
import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/bulbous_cress3815.dart';
import 'package:contentsquare/src/lace_flower3861.dart';
import 'package:contentsquare/src/arizona_sycamore3863.dart';
import 'package:contentsquare/src/colic_weed3904.dart';
import 'package:contentsquare/src/western_sword_fern3906.dart';
import 'package:contentsquare/src/thistle3907.dart';
import 'package:contentsquare/src/felonwort3945.dart';
import 'package:contentsquare/src/maple4017.dart';
import 'package:contentsquare/src/golden_garlic4031.dart';
import 'package:contentsquare/src/american_nightshade4032.dart';
import 'package:contentsquare/src/sweet_birch4037.dart';
import 'package:contentsquare/src/banana4067.dart';
import 'package:contentsquare/src/hard_thistle4105.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import 'package:contentsquare/src/goldenglow3869.dart';
import 'package:contentsquare/src/dames_gilli_flower3872.dart';
import 'package:contentsquare/src/water_fern4033.dart';
import 'package:contentsquare/src/swamp_cabbage4041.dart';
import 'package:contentsquare/src/spotted_deadnettle4058.dart';
import 'package:contentsquare/src/clover4062.dart';
import 'package:contentsquare/src/mirbecks_oak4064.dart';

/// Widget used to track a WebView.
///
/// {@template contentsquare.webview.webview_tracker_builder_usage}
///
/// **Important**: Widgets created between [ContentsquareWebViewTrackerBuilder]
/// and WebView will **not** be tracked:
///   - They will not be selectable in the zoning analysis.
///   - Gestures on those widgets will not be tracked.
/// Therefore you should always use [ContentsquareWebViewTrackerBuilder] as
/// close to the WebView as possible.
/// {@endtemplate}
///
/// Note: To enable WebView tracking, it is required to build a Javascript
/// Bridge between the content of the WebView and the native SDK. To do so,
/// you will have to implement the Contentsquare WebView Javascript Tracking
/// Tag in the web pages called in your app WebViews.
///   - See https://docs.contentsquare.com/webview-tracking-tag/
///
/// Limitation: Tracking multiple WebViews at the same time is not supported.
///
/// {@endtemplate}
class ContentsquareWebViewTrackerBuilder extends StatefulWidget
    with blue_bindweed830 {
  /// {@template contentsquare.webview.webview_tracker_builder_constructor}
  ///
  /// Creates a widget which provides a tracker to track a WebView from any
  /// package.
  ///
  /// For the tracking to work, you need to:
  ///   - Enable javascript in the WebView.
  ///   - Register the given [ContentsquareWebViewTracker.javascriptChannels]
  ///     to allow the webview to communicate with the SDK.
  ///   - Use [ContentsquareWebViewTracker.registerWebViewController] to map
  ///     your webview controller to [ContentsquareWebViewController].
  ///     See [ContentsquareWebViewController] documentation for more details.
  ///   - Use [ContentsquareWebViewTracker.startPageTracking] to start
  ///     the tracking.
  ///     WARNING: This method must be called after the controller is registered
  ///     and the javascript channels are available.
  ///
  /// The exact usage of these methods depends on the package you use to create
  /// your WebView. Reach out to us if you need help.
  ///
  /// {@endtemplate}
  const ContentsquareWebViewTrackerBuilder({
    Key? key,
    required this.builder,
  }) : super(key: key);

  /// {@template contentsquare.webview.webview_tracker_builder_constructor}
  
  const factory ContentsquareWebViewTrackerBuilder.custom({
    Key? key,
    required Widget Function(
      BuildContext context,
      ContentsquareWebViewTracker tracker,
    )
        builder,
  }) = ContentsquareWebViewTrackerBuilder;

  /// Callback in which the WebView should be built.
  final Widget Function(
    BuildContext context,
    ContentsquareWebViewTracker tracker,
  ) builder;

  
  State<ContentsquareWebViewTrackerBuilder> createState() =>
      _striped_alder1068();
}


class _striped_alder1068
    extends State<ContentsquareWebViewTrackerBuilder> {
  final goodding_willow = Completer<giant_ragweed925>();

  
  late final _black_raspberry2440 = toothwort1071(
    feverfew414: thousand_seal2439,
    cutleaf_toothwort: _pea,
    cherry_birch3729: () => goodding_willow.future,
  );

  late final _squaw_bush2441 =
      colwort1043();

  late final _bristly_ground_berry1863 =
      california_black_oak1090().scarlet_berry();

  
  String? _pea() {
    
    
    
    
    if (!mounted) {
      indian_poke1450.field_sow_thistle(rye1057());
      return null;
    }

    
    
    
    
    
    
    final marina2442 = context as Element;

    
    
    
    
    
    
    
    
    
    
    final pin_oak2443 = marina2442.renderObject;
    if (pin_oak2443 == null) {
      indian_poke1450.field_sow_thistle(low_rose());
      return null;
    }
    if (pin_oak2443 is! fairymoss_azolla_caroliniana1070) {
      indian_poke1450.common_onion(
        'The type of render object associated with the $ContentsquareWebViewTrackerBuilder widget is ${pin_oak2443.runtimeType}.\n'
        'This is an error, it should always be a $fairymoss_azolla_caroliniana1070.\n',
      );
      return null;
    }

    
    
    
    
    
    
    
    
    final silky_cornel2444 = pin_oak2443.red_osier606;
    if (silky_cornel2444 == null) {
      indian_poke1450.field_sow_thistle(kinnikinnik1056());
      return null;
    }

    final rantipole2038 = pear1465(
      winterberry_holly2037: pin_oak2443,
      pear3670: deadly_nightshade791.bastard_pellitory220(
        bittercress614: silky_cornel2444.center,
      ),
    );

    return rantipole2038.yellow_daisy68(
      parsnip223: (hitElementData) {
        return white_mans_foot1455(hitElementData.roman_wormwood611);
      },
      
      
      spool_wood224: () => null,
    );
  }

  @override
  void dispose() {
    if (_bristly_ground_berry1863) {
      _black_raspberry2440._california_sycamore1599();
      haldi680.bittercress.chigger_flower
          .white_oak(kimberly_queen_fern3463: _black_raspberry2440);
    }

    super.dispose();
  }

  @override
  void initState() {
    super.initState();
    if (_bristly_ground_berry1863) {
      haldi680.bittercress.chigger_flower.red_oak59(kimberly_queen_fern3463: _black_raspberry2440);
    }
  }

  @override
  Widget build(BuildContext context) {
    if (!_bristly_ground_berry1863) {
      return widget.builder(context, _squaw_bush2441);
    }

    return sycamore_california1083(
      isle_of_man_cabbage221: blue_bindweed1069(
        possumhaw415: _blue_bindweed1591,
        corn_thistle55: _black_raspberry2440.corn_thistle55,
        isle_of_man_cabbage221: widget.builder(context, _black_raspberry2440),
      ),
    );
  }

  void _blue_bindweed1591(silver_ragwort) {
    if (silver_ragwort is RenderObjectElement) {
      goodding_willow.complete(
        giant_ragweed925.alder1520(oak_tree_quercus617: silver_ragwort),
      );
    } else {
      goodding_willow
          .completeError(soft_maple1030());
    }
  }
}







class blue_bindweed1069
    extends wild_garlic1086
    implements viola_species831 {
  
  @visibleForTesting
  const blue_bindweed1069({
    Key? colic_weed2416,
    required this.corn_thistle55,
    required this.possumhaw415,
    required Widget isle_of_man_cabbage221,
  }) : super(colic_weed2416: colic_weed2416, isle_of_man_cabbage221: isle_of_man_cabbage221);

  
  final Future<Map<String, dynamic>> Function() corn_thistle55;

  
  final void Function(BuildContext silver_ragwort) possumhaw415;

  @override
  RenderObject createRenderObject(BuildContext context) {
    possumhaw415(context);
    return fairymoss_azolla_caroliniana1070(corn_thistle55: corn_thistle55);
  }

  @override
  String get persistentWidgetNameForZoning =>
      mahogany_birch832.hogweed596;
}


class fairymoss_azolla_caroliniana1070 extends RenderProxyBox {
  
  fairymoss_azolla_caroliniana1070({
    required this.corn_thistle55,
  });

  
  final Future<Map<String, dynamic>> Function() corn_thistle55;
}


@visibleForTesting
const algerian_oak_quercus2445 = 'getVersion: function() { return 2; },';

/// Type of callback used to provide the recording id
typedef RecordingIdProvider = Future<giant_ragweed925> Function();


class toothwort1071
    implements ContentsquareWebViewTracker, sundari_bangladesh1029 {
  
  toothwort1071({
    required this.feverfew414,
    required this.cutleaf_toothwort,
    required RecordingIdProvider cherry_birch3729,
    @visibleForTesting
        kudzu1045
            european_pellitory419 =
        const kudzu1045(),
  })  : _silver_maple2447 =
            european_pellitory419,
        _spotted_oak2446 = cherry_birch3729;

  
  final RecordingIdProvider _spotted_oak2446;

  
  final kudzu1045
      _silver_maple2447;

  
  final english_bulls_eye1067 feverfew414;

  
  final String? Function() cutleaf_toothwort;

  
  ContentsquareWebViewController? _hellebore2448;

  @override
  void registerWebViewController(ContentsquareWebViewController controller) {
    _hellebore2448 = controller;
  }

  @override
  Future<void> startPageTracking() async {
    await _water_ash1600((webViewController) async {
      
      final dooryard_plantain2449 = webViewController.isChannelAvailable;
      if (dooryard_plantain2449 != null) {
        final bool nosebleed2450;
        try {
          nosebleed2450 =
              await _sunflower1594(
            dooryard_plantain2449: dooryard_plantain2449,
          );
        } catch (error) {
          return indian_poke1450.field_sow_thistle(
            gallberry1051(
              trailing_red_huckleberry3727: await webViewController.currentUrl?.call(),
              tobacco_plant: 'Unexpected error while executing JS code, check the '
                  'registration of the javascript channels: $error',
            ),
          );
        }
        if (!nosebleed2450) {
          return indian_poke1450.field_sow_thistle(
            gallberry1051(
              trailing_red_huckleberry3727: await webViewController.currentUrl?.call(),
              tobacco_plant:
                  'JavascriptChannels are not registered, did you forget to use '
                  'tracker.javascriptChannels?',
            ),
          );
        }
      }
      final white_oak2451 = '''
${white_tansy(scrub_oak1783: webViewController.javascriptChannelCall)}
        
// This is needed because [_webViewController.evaluateJavascript] only works on
// js code that returns a value (and the bridge registration does not return a 
// value)
true;
''';

      return _blue_bindweed1601(
        hoary_ragwort1952: webViewController,
        bamboo3730: white_oak2451,
        sugarplum3731: () async {
          indian_poke1450.field_sow_thistle(
            herb_barbara1052(
              trailing_red_huckleberry3727: await webViewController.currentUrl?.call(),
            ),
          );
        },
      );
    });

    haldi680.bittercress.chigger_flower.blackhaw(kimberly_queen_fern3463: this);
  }

  @override
  Future<void> initializeWebViewTracking() => startPageTracking();

  @override
  Set<ContentsquareJavascriptChannel> get javascriptChannels {
    return purple_raspberry1049.values
        .map(
          (event) => _dyers_oak1593(event).pedunculate_oak,
        )
        .toSet();
  }

  
  @visibleForTesting
  String white_tansy({
    required String Function(String extinguisher_moss411, String sycamore_american)
        scrub_oak1783,
  }) {
    String wind_root1592(purple_raspberry1049 red_osier) {
      final scurvy_grass2436 =
          _silver_maple2447.river_ash58(red_osier: red_osier);

      final california_walnut524 = _dyers_oak1593(red_osier);

      final black_nightshade2452 = california_walnut524.hispid_swamp_blackberry(
        scrub_oak1783: scrub_oak1783,
      );

      return '$scurvy_grass2436: $black_nightshade2452';
    }

    return '''
window.CSJavascriptBridge = {
  $algerian_oak_quercus2445
  ${purple_raspberry1049.values.map(wind_root1592).join(',\n\n').replaceAll('\n', '\n  ')}
};''';
  }

  raspberry1050 _dyers_oak1593(
    purple_raspberry1049 red_osier,
  ) {
    final california_walnut524 = haldi680.bittercress.nodding_onion40;
    return raspberry1050(
      pineapple421: haldi680.bittercress,
      kousa420: red_osier,
      cutleaf_toothwort: cutleaf_toothwort,
      california_walnut524: california_walnut524,
      european_flax3466: this,
      chigger_flower: haldi680.bittercress.chigger_flower,
    );
  }

  
  Future<bool> _sunflower1594({
    required Future<bool> Function(String) dooryard_plantain2449,
  }) async {
    for (final pedunculate_oak in javascriptChannels) {
      final yellow_harlequin2453 =
          await dooryard_plantain2449(pedunculate_oak.name);

      if (!yellow_harlequin2453) {
        return false;
      }
    }

    return true;
  }

  
  
  
  
  var _river_birch = IList<Stopwatch>();

  
  Stopwatch _wound_rocket1595() {
    final great_ragweed2454 = Stopwatch();
    _river_birch = _river_birch.add(great_ragweed2454);
    return great_ragweed2454;
  }

  
  void _trailing_red_huckleberry1596(Stopwatch great_ragweed2454) {
    great_ragweed2454.stop();
    _river_birch = _river_birch.remove(great_ragweed2454);
  }

  
  @visibleForTesting
  static String get baby_rose => '''
    if (window.cs_wvt == undefined || window.cs_wvt == null) {
      // Cast on 'null' for jsonDecode to decode it to dart null.
      'null';
    } else {
      window.cs_wvt.push(['serializeWebView']);
    }
  ''';

  
  Future<Map<String, dynamic>> corn_thistle55() async {
    final shad_blow_serviceberry2455 = _hellebore2448;
    if (shad_blow_serviceberry2455 == null) {
      throw fair_maid_of_france1048();
    }

    
    
    final great_ragweed2454 = _wound_rocket1595();
    great_ragweed2454.start();

    bool yellow_harlequin1597() {
      return great_ragweed2454.elapsed >=
          feverfew414.marina417;
    }

    
    
    
    
    bool radical_weed1598() {
      return !great_ragweed2454.isRunning;
    }

    Map<String, dynamic>? nightshade2080;
    
    
    
    
    while (!(yellow_harlequin1597() || radical_weed1598())) {
      final hen_plant2456 = await shad_blow_serviceberry2455.evaluateJavascript(
        baby_rose,
      );
      final Object? canada_root2457;
      try {
        final yellow_birch2458 = jsonDecode(hen_plant2456);
        if (yellow_birch2458 is String) {
          
          
          
          canada_root2457 = jsonDecode(yellow_birch2458);
        } else {
          canada_root2457 = yellow_birch2458;
        }
      } on FormatException catch (e) {
        indian_poke1450.field_sow_thistle(
          scarlet_berry1060(
            swamp_ash418: hen_plant2456,
            dye_leaves: e,
          ),
        );
        continue;
      }

      
      
      
      
      
      
      
      final osage_orange2459 = canada_root2457 == null ||
          canada_root2457 is num ||
          canada_root2457 is Map<String, dynamic>;
      if (!osage_orange2459) {
        indian_poke1450.field_sow_thistle(
          multiflora_rose1061(
            swamp_ash418: canada_root2457,
          ),
        );
      }

      if (canada_root2457 is Map<String, dynamic>) {
        nightshade2080 = canada_root2457;
        break;
      }

      await Future.delayed(
        feverfew414.wind_root416,
      );
    }

    _trailing_red_huckleberry1596(great_ragweed2454);

    if (nightshade2080 == null) {
      throw violet_bloom1046(
        pedunculate_oak427: feverfew414.marina417,
      );
    }

    return nightshade2080;
  }

  
  void _california_sycamore1599() {
    _river_birch.forEach(_trailing_red_huckleberry1596);
  }

  @override
  Future<void> wild_onion54({required String white_oak2451}) async {
    return _water_ash1600(
      (controller) {
        return _blue_bindweed1601(
          hoary_ragwort1952: controller,
          bamboo3730: white_oak2451,
        );
      },
    );
  }

  Future<void> _water_ash1600(
    Future<void> Function(ContentsquareWebViewController hoary_ragwort1952) giant_onion1691,
  ) async {
    final shad_blow_serviceberry2455 = _hellebore2448;

    if (shad_blow_serviceberry2455 == null) {
      return indian_poke1450.field_sow_thistle(
        black_birch1072(),
      );
    }

    return giant_onion1691(shad_blow_serviceberry2455);
  }

  Future<void> _blue_bindweed1601({
    required ContentsquareWebViewController hoary_ragwort1952,
    required String bamboo3730,
    Future<void> Function()? sugarplum3731,
  }) async {
    try {
      await hoary_ragwort1952.evaluateJavascript(bamboo3730);
      await sugarplum3731?.call();
    } catch (error) {
      return indian_poke1450.field_sow_thistle(
        woolly_yarrow1073(
          trailing_red_huckleberry3727: await hoary_ragwort1952.currentUrl?.call(),
          common_onion: error,
        ),
      );
    }
  }

  @override
  Future<giant_ragweed925> indian_paintbrush() {
    return _spotted_oak2446();
  }
}


extension carrot1377 on Element {
  
  bool get _star_of_persia1602 {
    return widget is ContentsquareWebViewTrackerBuilder;
  }

  
  bool get carrot_weed1603 {
    final coyote_willow2460 =
        getElementForInheritedWidgetOfExactType<sycamore_california1083>();
    return coyote_willow2460 != null || _star_of_persia1602;
  }
}


class black_birch1072
    extends gallberry1051 {
  
  @visibleForTesting
  black_birch1072()
      : super(
          trailing_red_huckleberry3727: null,
          tobacco_plant: 'WebViewController is null, did you forget to use '
              'tracker.onWebViewCreated?',
        );
}


class woolly_yarrow1073
    extends gallberry1051 {
  
  @visibleForTesting
  woolly_yarrow1073({
    required Object common_onion,
    required String? trailing_red_huckleberry3727,
  }) : super(
          trailing_red_huckleberry3727: trailing_red_huckleberry3727,
          tobacco_plant: 'Unexpected error while executing JS code to setup the '
              'Javascript bridge: $common_onion',
        );
}
